C************************************************************
C   This program reads the raw ascii file generated by Fuji 
C   thermomechanical simultor situated at University of 
C   Cambridge.  
C
C
C   Why this program is needed?
C    Theromechanical simulator dumps the data in an ascii 
C    format and it contains only one line.  All the need to 
C    be read by rewinding each time you read one block of 
C    data.
C
C************************************************************
        PARAMETER(NPOINT=4200)
C
C This parameter has to be changed to higher value, if you 
C collect more than 4200
C data points.
C
        IMPLICIT REAL*8(A-H,O-Z), INTEGER(I-N)
        CHARACTER*50 IFILE(4)
        CHARACTER*3 IMODE
        DIMENSION SS(NPOINT),SN(NPOINT),TP(NPOINT),DL(NPOINT)
        DIMENSION TIME1(4200),TIME2(4200)
        DIMENSION TBL(12), SBL(12)
C************************************************************
C       The blocks of data are 12 and if you exceed them
C       please change accordingly and also in the program
C       below to read all the data.
C************************************************************
        WRITE (*,9799)
9799    FORMAT('  MODIFIED FOR AN NOMINAL OFFSET OF 0.1MM')
C************************************************************
C
C This is the set up for thermomechanical simulator 
C situated in University of Cambridge.
C
C************************************************************
C  Initializing
C************************************************************
         NSS = 0
         NSN = 0
         NTP = 0
         NDL = 0
        IUNIT1 = 1
        IUNIT2 = 2
        IUNIT3 = 3
        IUNIT4 = 4
        IUNIT5 = 5
        IUNIT6 = 6
C------------------------------------------------------------------------------
C       FIRST STEP TO RECODE ALL DATA IN COLUMN FORMAT FROM ORIGINAL DATA FILE
C------------------------------------------------------------------------------
        CALL TITLE
C------------------------------------------------------------------------------
        WRITE(*,*) 'THERMO MECHANICAL SIMULATOR ASCII FILE NAME'
        READ(*,'(A50)') IFILE(1)
        WRITE(*,99990)
        WRITE(*,*) 'WHAT KIND OF DATA FILE; Key in the Number'
        WRITE(*,*) 'TD  DATA FILE     ---->  1                '
        WRITE(*,*) 'SS  DATA FILE     ---->  2                '
        WRITE(*,*) 'ALL DATA FILE     ---->  3                '
        READ(5,*) ITYPE
        WRITE(*,99990)
        OPEN(UNIT=IUNIT1, FILE=IFILE(1))
        REWIND(IUNIT1)
        CALL RECOM(DIA,DLEN,DLO,STR,IMODE,IUNIT1,ITYPE)
C------------------------------------------------------------------------------
C       NOW READING THE DATA
C------------------------------------------------------------------------------
C       TD MODE
C------------------------------------------------------------------------------
        IF (ITYPE .EQ. 1) THEN
        READ(IUNIT1,99991) NTP,NDL
        WRITE (*,99990)
        WRITE (*,*) 'NUMBER OF TEMP DATA =', NTP
        WRITE (*,*) 'NUMBER OF DILA DATA =', NDL
        WRITE (*,99990)
        REWIND(IUNIT1)
        READ(IUNIT1,99993) NBT
        WRITE (*,*) 'NUMBER OF (TEMP) DATA BLOCKS = ', NBT
        REWIND(IUNIT1)
        READ(IUNIT1, 99994) (TBL(J), J=1,NBT)
        DO 222 KL = 1, NBT
        WRITE (*,*) 'TIME INTERVAL FOR TD',KL,'BLOCK=',TBL(KL)
222     CONTINUE
        REWIND(IUNIT1)
        NTPRIM = (NTP/63 + 1)*63
        NLPRIM = (NDL/63 + 1)*63
        READ(IUNIT1, 99995) (TP(I),I=1,NTPRIM),(DL(I),I=1,NLPRIM)
	
        GOTO 100
        ENDIF
C------------------------------------------------------------------------------
C       SS MODE
C------------------------------------------------------------------------------
        IF (ITYPE .EQ. 2) THEN
        READ(IUNIT1,99991) NSN,NSS
        WRITE (*,99990)
        WRITE (*,*) 'NUMBER OF SS DATA =', NSS
        WRITE (*,*) 'NUMBER OF SN DATA =', NSN
	
	NTP = 0
        WRITE (*,99990)
        REWIND(IUNIT1)
        READ(IUNIT1,99993) NST
        WRITE (*,*) 'NUMBER OF ( SS ) DATA BLOCKS = ', NST
        REWIND(IUNIT1)
        READ(IUNIT1, 99994) (SBL(J), J=1,NST)
        DO 223 KL = 1, NST
        WRITE (*,*) 'TIME INTERVAL FOR SS',KL,'BLOCK=',SBL(KL)
223     CONTINUE
        REWIND(IUNIT1)
        NSPRIM = (NSS/63 + 1)*63
        NNPRIM = (NSN/63 + 1)*63
        READ(IUNIT1, 99995) (SN(I),I=1,NNPRIM),(SS(I),I=1,NSPRIM)
        GOTO 100
        ENDIF
C------------------------------------------------------------------------------
C       ALL MODE
C------------------------------------------------------------------------------
        IF (ITYPE .EQ. 3) THEN
        READ(IUNIT1,99992) NSN,NSS,NTP,NDL
        WRITE (*,99990)
        WRITE (*,*) 'NUMBER OF SS   DATA =', NSS
        WRITE (*,*) 'NUMBER OF SN   DATA =', NSN
        WRITE (*,*) 'NUMBER OF TEMP DATA =', NTP
        WRITE (*,*) 'NUMBER OF DILA DATA =', NDL
        WRITE (*,99990)
        REWIND(IUNIT1)
        READ(IUNIT1,99993) NST
        WRITE (*,*) 'NUMBER OF ( SS ) DATA BLOCKS = ', NST
        REWIND(IUNIT1)
        READ(IUNIT1, 99994) (SBL(J), J=1,NST)
        REWIND(IUNIT1)
                       IF (NST .EQ. 1)  THEN
                       READ(IUNIT1, 10001) NBT
                       WRITE (*,*)'NUMBER OF (TEMP) DATA BLOCKS = ',NBT
                       REWIND(IUNIT1)
                       READ(IUNIT1, 10002) (TBL(J), J=1,NBT)
                       REWIND(IUNIT1)
                       ENDIF
                       IF (NST .EQ. 2)  THEN
                       READ(IUNIT1, 10003) NBT
                       WRITE (*,*)'NUMBER OF (TEMP) DATA BLOCKS = ',NBT
                       REWIND(IUNIT1)
                       READ(IUNIT1, 10004) (TBL(J), J=1,NBT)
                       REWIND(IUNIT1)
                       ENDIF
                       IF (NST .EQ. 3)  THEN
                       READ(IUNIT1, 10005) NBT
                       WRITE (*,*)'NUMBER OF (TEMP) DATA BLOCKS = ',NBT
                       REWIND(IUNIT1)
                       READ(IUNIT1, 10006) (TBL(J), J=1,NBT)
                       REWIND(IUNIT1)
                       ENDIF
                       IF (NST .EQ. 4)  THEN
                       READ(IUNIT1, 10007) NBT
                       WRITE (*,*)'NUMBER OF (TEMP) DATA BLOCKS = ',NBT
                       REWIND(IUNIT1)
                       READ(IUNIT1, 10008) (TBL(J), J=1,NBT)
                       REWIND(IUNIT1)
                       ENDIF
                       IF (NST .EQ. 5)  THEN
                       READ(IUNIT1, 10009) NBT
                       WRITE (*,*)'NUMBER OF (TEMP) DATA BLOCKS = ',NBT
                       REWIND(IUNIT1)
                       READ(IUNIT1, 10010) (TBL(J), J=1,NBT)
                       REWIND(IUNIT1)
                       ENDIF
                       IF (NST .EQ. 6)  THEN
                       READ(IUNIT1, 10011) NBT
                       WRITE (*,*)'NUMBER OF (TEMP) DATA BLOCKS = ',NBT
                       REWIND(IUNIT1)
                       READ(IUNIT1, 10012) (TBL(J), J=1,NBT)
                       REWIND(IUNIT1)
                       ENDIF
                       IF (NST .EQ. 7)  THEN
                       READ(IUNIT1, 10013) NBT
                       WRITE (*,*)'NUMBER OF (TEMP) DATA BLOCKS = ',NBT
                       REWIND(IUNIT1)
                       READ(IUNIT1, 10014) (TBL(J), J=1,NBT)
                       REWIND(IUNIT1)
                       ENDIF
                       IF (NST .EQ. 8)  THEN
                       READ(IUNIT1, 10015) NBT
                       WRITE (*,*)'NUMBER OF (TEMP) DATA BLOCKS = ',NBT
                       REWIND(IUNIT1)
                       READ(IUNIT1, 10016) (TBL(J), J=1,NBT)
                       REWIND(IUNIT1)
                       ENDIF
        DO 224 KL = 1, NBT
        WRITE (*,*) 'TIME INTERVAL FOR TD',KL,'BLOCK=',TBL(KL)
224     CONTINUE
        DO 225 KL = 1, NST
        WRITE (*,*) 'TIME INTERVAL FOR SS',KL,'BLOCK=',SBL(KL)
225     CONTINUE
        NTPRIM = (NTP/63 + 1)*63
        NLPRIM = (NDL/63 + 1)*63
        NSPRIM = (NSS/63 + 1)*63
        NNPRIM = (NSN/63 + 1)*63
        READ(IUNIT1, 99995) (SN(I),I=1,NNPRIM),(SS(I),I=1,NSPRIM),
     &                      (TP(I),I=1,NTPRIM),(DL(I),I=1,NLPRIM)
        ENDIF
C
C------------------------------------------------------------------------------
100     CLOSE(IUNIT1)
C------------------------------------------------------------------------------
        CALL CONVER(TP,DL,SN,SS,DIA,DLEN,DLO,STR,IMODE,NTP,NSN,ITYPE)
C------------------------------------------------------------------------------
        CALL TIMCAL(TIME1,TIME2,TBL,SBL,NBT,NST,NTP,NSN,ITYPE)
        WRITE(*,*) 'PHX TRANSFER ASCII FILE NAME'
        READ(*,'(A50)') IFILE(2)
        OPEN(UNIT=IUNIT2, FILE=IFILE(2))
        CALL WRIT(TP,DL,TIME1,SN,SS,TIME2,NTP,NSN,IUNIT2)
99991   FORMAT(4X,I4,3X,I4)
99992   FORMAT(4X,I4,3X,I4,3X,I4,3X,I4)
99993   FORMAT(31X,I1)
99994   FORMAT(32X,8(1X,F12.0))
99995   FORMAT(256X,256X, 300(63F4.0,4X))
10016                  FORMAT(32X,1X,8(12X,1X),1X,1X,8(1X,F12.0))
10015                  FORMAT(32X,1X,8(12X,1X),1X,I1)
10014                  FORMAT(32X,1X,7(12X,1X),1X,1X,8(1X,F12.0))
10013                  FORMAT(32X,1X,7(12X,1X),1X,I1)
10012                  FORMAT(32X,1X,6(12X,1X),1X,1X,8(1X,F12.0))
10011                  FORMAT(32X,1X,6(12X,1X),1X,I1)
10010                  FORMAT(32X,1X,5(12X,1X),1X,1X,8(1X,F12.0))
10009                  FORMAT(32X,1X,5(12X,1X),1X,I1)
10008                  FORMAT(32X,1X,4(12X,1X),1X,1X,8(1X,F12.0))
10007                  FORMAT(32X,1X,4(12X,1X),1X,I1)
10006                  FORMAT(32X,1X,3(12X,1X),1X,1X,8(1X,F12.0))
10005                  FORMAT(32X,1X,3(12X,1X),1X,I1)
10004                  FORMAT(32X,1X,2(12X,1X),1X,1X,8(1X,F12.0))
10003                  FORMAT(32X,1X,2(12X,1X),1X,I1)
10002                  FORMAT(32X,1X,1(12X,1X),1X,1X,8(1X,F12.0))
10001                  FORMAT(32X,1X,1(12X,1X),1X,I1)
99990   FORMAT(
     &1X,'------------------------------------------------------------')
        STOP
        END
C------------------------------------------------------------------------------
        SUBROUTINE TITLE
        IMPLICIT REAL*8(A-H,O-Z), INTEGER(I-N)
        WRITE(*,*) '---------------------------------------------------'
        WRITE(*,*) 'Thermo Mechanical Simulator Ascii Code Manipulation'
        WRITE(*,*) '               S. Suresh Babu                      '
        WRITE(*,*) '                  June, 1991                       '
        WRITE(*,*) '---------------------------------------------------'
        RETURN
        END
C------------------------------------------------------------------------------
        SUBROUTINE RECOM(DIA,DL,DLO,STR,IMODE,IUNIT1,ITYPE)
        IMPLICIT REAL*8(A-H,O-Z), INTEGER(I-N)
        CHARACTER*29 ICOM1
        CHARACTER*14 ICOOL
        CHARACTER*11 ICONT
        CHARACTER*18 IDTF
        CHARACTER*7  IMODE2
        CHARACTER*3   IMODE
        CHARACTER*2  IM1,IM2,IM4
        CHARACTER*1   IM3
        IF (ITYPE .NE. 2) THEN
        READ(IUNIT1,1) ICOM1,DIA,IM1,DL,IM2,ICOOL,IMODE2,IMODE,
     &                 DLO,IM3,STR,IM4,
     &                 IDTF,ICONT
                       ELSE
        READ(IUNIT1,11) ICOM1,DIA,IM1,DL,IM2,
     &                 DLO,IM3,STR,IM4,
     &                 IDTF,ICONT
                       ENDIF
        WRITE(*,2)
        WRITE(*,*)'THE DATA OF FILE AS FOLLOWS'
        WRITE(*,3) ICOM1,ICOOL,IMODE,IMODE2,IDTF,ICONT
        WRITE(*,4) DIA,IM2,DL,IM2,DLO,IM3,STR,IM4
        WRITE(*,2)
        WRITE (*,*) 'IS IT OK?'
        WRITE (*,*) 'YES -> 1, NO -> 2'
        READ (*,*) IPRO
        IF (IPRO .EQ. 2)  THEN
        REWIND(IUNIT1)
        STOP
        ENDIF
        REWIND(IUNIT1)
        RETURN
1       FORMAT(256X,A29, 2(2X,F6.2,A2,1X), A14,A7,A3,1X,
     &                     5X,F5.0,A1,1X ,
     &                     7X,F5.2,A2,1X ,
     &                     A18, A11)
11      FORMAT(256X,A29, 2(2X,F6.2,A2,1X), 25X,
     &                     5X,F5.0,A1,1X ,
     &                     7X,F5.2,A2,1X ,
     &                     A18, A11)
2       FORMAT(
     &1X,'------------------------------------------------------------')
3       FORMAT(1X,A29,/1X,A14,/1X,A3,1X,A7/1X,A18,/1X,A12)
4       FORMAT(1X,'DIAMETER OF THE SAMPLE =', F6.2,A2,/
     &         1X,'LENGTH   OF THE SAMPLE =', F6.2,A2,/
     &         1X,'LOAD RANGE USED        =', F5.0,A1,/
     &         1X,'STROKE LENGTH USED     =', F5.2,A2,/)
        END
C------------------------------------------------------------------------------
        SUBROUTINE TIMCAL(TIME1,TIME2,TBL,SBL,NBT,NST,N1,N2,ITYPE)
        IMPLICIT REAL*8(A-H,O-Z), INTEGER(I-N)
        DIMENSION TIME1(0:N1), TIME2(0:N2)
        DIMENSION TBL(NBT),SBL(NST)
        write(6,*) '***', N1, N2

	if (N1 .GT. 0)          TIME1(1) = 0.0
        if (N2 .GT. 0)          TIME2(1) = 0.0

        IF ( (ITYPE .EQ. 1) .OR. (ITYPE .EQ. 3)) THEN
        NTP1 = N1/NBT
        IBT = 1
        IBB = NTP1
        DINI = 0.0
C              WRITE(*,*) 'CHECK = NTP1', NTP1
        DO 10 I = 2, N1
        IF (I .LE. IBB)                     THEN
        TIME1(I) = DINI + (I-(IBT-1)*NTP1-1)*TBL(IBT)
        DPREV = TIME1(I)
        TIME1(I) = TIME1(I)/1.0E+06
                                            ELSE
        IBB  = IBB + NTP1
        DINI = DPREV
        IBT = IBT + 1
C       WRITE (*,*) 'CHECK I AM IN',IBT,'BLOCK AND TIME=',TBL(IBT)
        TIME1(I) = DINI + TBL(IBT)
        TIME1(I) = TIME1(I)/1.0E+06
                                           ENDIF
10      CONTINUE
                                                ENDIF
        IF ( (ITYPE .EQ. 2) .OR. (ITYPE .EQ. 3)) THEN
        DINI = 0.0
        IST = 1
        NSN1 = N2/NST
        ISB = NSN1
C        WRITE(*,*) 'CHECK = NSN1', NSN1
        IST = 1
        ISB = NSN1
        DINI = 0.0
        DO 20 I = 2, N2
        IF (I .LE. ISB)                     THEN
        TIME2(I) = DINI + (I-(IST-1)*NSN1-1)*SBL(IST)
        DPREV = TIME2(I)
        TIME2(I) = TIME2(I)/1.0E+06
                                            ELSE
        ISB  = ISB+ NSN1
        DINI = DPREV
        IST = IST + 1
C        WRITE (*,*) 'CHECK I AM IN',IST,'BLOCK AND TIME=',SBL(IST)
        TIME2(I) = DINI + SBL(IST)
        TIME2(I) = TIME2(I)/1.0E+06
                                           ENDIF
20      CONTINUE
                                                ENDIF
        RETURN
        END
C------------------------------------------------------------------------------
        SUBROUTINE WRIT(TP,DL,TIME1,SN,SS,TIME2,N1,N2,IUNIT2)
        IMPLICIT REAL*8(A-H,O-Z), INTEGER(I-N)
        DIMENSION TP(N1), DL(N1), TIME1(N1)
        DIMENSION SN(N2), SS(N2), TIME2(N2)
        WRITE (IUNIT2,1)

        IF (N1 .GE. N2)              THEN
        DO 10 I = 1,N1
        IF (I .LE. N2)   THEN
        WRITE (IUNIT2,2)TP(I),DL(I),TIME1(I),SS(I),SN(I),TIME2(I)
                         ELSE
        WRITE (IUNIT2,3) TP(I),DL(I),TIME1(I)
                         ENDIF
10      CONTINUE
                                     ELSE
        DO 20 I = 1, N2
        IF (I .LE. N1)   THEN
        WRITE (IUNIT2,2)TP(I),DL(I),TIME1(I),SS(I),SN(I),TIME2(I)
                         ELSE
        WRITE (IUNIT2,4) SS(I),SN(I),TIME2(I)
                         ENDIF
20      CONTINUE
                                     ENDIF
1       FORMAT(1X,
     & '   TEMP C   ',2X,'   DD/D     ',2X,'   TIME1/ S ',2X,
     & '   LOAD N   ',2X,' STRAIN SN/L',2X,'   TIME2/ S ',2X)
2       FORMAT(1X,6(1X,E12.4,1X))
3       FORMAT(1X,3(1X,E12.4,1X))
4       FORMAT(1X,42X,3(1X,E12.4,1X))
        RETURN
        END
C------------------------------------------------------------------------------
        SUBROUTINE CONVER(TP,DL,SN,SS,DIA,DLEN,DLO,STR,IMODE,
     &  NTP,NSN,ITYPE)
        IMPLICIT REAL*8(A-H,O-Z), INTEGER(I-N)
        DIMENSION TP(NTP),DL(NTP),SS(NSN),SN(NSN)
        DIMENSION TK(4200)
        CHARACTER*3 IMODE
        DMAG = 4095.0D+00
        WRITE (*,*) 'MAX LOAD   RANGE USED IN THE EXP=', DLO
        WRITE (*,*) 'MAX DISPLACEMENT USED IN THE EXP=', STR
        WRITE (*,*) 'DIAMETER OF THE SAMPLE          =', DIA
        WRITE (*,*) 'LENGTH   OF THE SAMPLE          =', DLEN
        WRITE (*,1)  IMODE
        WRITE (*,*) 'IS IT OK? YES ->1 : NO-> 2'
        READ  (*,*) IPRO
        IF (IPRO .EQ. 2) STOP
C-------------------------------------------
        IF (IMODE .EQ. 'DIF') THEN
        DNUMER = 0.4D+00
                              ENDIF
        IF (IMODE .EQ. 'ABS') THEN
        WRITE (*,*) 'GOSH I AM RETIRING  I CAN NOT DO IT'
        WRITE (*,*) 'ASK DR MATZUZAKI 4495 OR 4336'
        STOP
                              ENDIF
C-------------------------------------------

        IF ((ITYPE .EQ. 1) .OR. (ITYPE .EQ. 3)) THEN
		
        DO 10 I = 1, NTP
        TK(I) = TP(I)+273.00D+00
	DL(I) = (DL(I)/DMAG - 0.25D+00)*DNUMER/DIA
C
C       CHECK FOR DEL/L
C
10      CONTINUE
                                               ENDIF
        IF ((ITYPE .EQ. 2) .OR. (ITYPE .EQ. 3)) THEN
        DO 20 I = 1, NSN
        SN(I) = (SN(I)/DMAG - 0.5)*STR/DLEN
C
C       STRAIN ?
C
        SS(I) = (SS(I)/DMAG - 0.5)*DLO
C
C       LOAD ONLY
C
20      CONTINUE
1       FORMAT(1X,'MODE OF DILATION=',A3)
                                               ENDIF
        RETURN
        END

